org.apache.lucene.collation

## Class ICUCollationKeyAnalyzer

- java.lang.Object
- - org.apache.lucene.analysis.Analyzer
  - - org.apache.lucene.collation.ICUCollationKeyAnalyzer

All Implemented Interfaces:
  Closeable, AutoCloseable

    public final class ICUCollationKeyAnalyzer
    extends Analyzer

Configures `KeywordTokenizer` with `ICUCollationAttributeFactory`.

Converts the token into its `CollationKey`, and then encodes the CollationKey either directly or with `IndexableBinaryStringTools` (see below), to allow it to be stored as an index term.

WARNING: Make sure you use exactly the same Collator at index and query time -- CollationKeys are only comparable when produced by the same Collator. `RuleBasedCollator`s are independently versioned, so it is safe to search against stored CollationKeys if the following are exactly the same (best practice is to store this information with the index and check that they remain the same at query time):

1. Collator version - see `Collator.getVersion()`
2. The collation strength used - see `Collator.setStrength(int)`

CollationKeys generated by ICU Collators are not compatible with those generated by java.text.Collators. Specifically, if you use ICUCollationKeyAnalyzer to generate index terms, do not use `CollationKeyAnalyzer` on the query side, or vice versa.

ICUCollationKeyAnalyzer is significantly faster and generates significantly shorter keys than CollationKeyAnalyzer. See http://site.icu-project.org/charts/collation-icu4j-sun for key generation timing and key length comparisons between ICU4J and java.text.Collator over several languages.

You must specify the required `Version` compatibility when creating ICUCollationKeyAnalyzer:

- As of 4.0, Collation Keys are directly encoded as bytes. Previous versions will encode the bytes with `IndexableBinaryStringTools`.

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.lucene.analysis.Analyzer

`Analyzer.GlobalReuseStrategy, Analyzer.PerFieldReuseStrategy, Analyzer.ReuseStrategy, Analyzer.TokenStreamComponents`

### Constructor Summary

Constructors
Constructor and Description
`ICUCollationKeyAnalyzer(com.ibm.icu.text.Collator collator)` Deprecated. Use `ICUCollationKeyAnalyzer(Version, Collator)` and specify a version instead. This ctor will be removed in Lucene 5.0
`ICUCollationKeyAnalyzer(Version matchVersion, com.ibm.icu.text.Collator collator)` Create a new ICUCollationKeyAnalyzer, using the specified collator.

### Method Summary

Methods
`protected Analyzer.TokenStreamComponents` `createComponents(String fieldName, Reader reader)`

### Methods inherited from class org.apache.lucene.analysis.Analyzer

`close, getOffsetGap, getPositionIncrementGap, initReader, tokenStream`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ICUCollationKeyAnalyzer

    public ICUCollationKeyAnalyzer(Version matchVersion,
                           com.ibm.icu.text.Collator collator)

Create a new ICUCollationKeyAnalyzer, using the specified collator.

Parameters:
  `matchVersion` - See above
  `collator` - CollationKey generator

#### ICUCollationKeyAnalyzer

    @Deprecated
    public ICUCollationKeyAnalyzer(com.ibm.icu.text.Collator collator)

Deprecated. Use `ICUCollationKeyAnalyzer(Version, Collator)` and specify a version instead. This ctor will be removed in Lucene 5.0

### Method Detail

#### createComponents

    protected Analyzer.TokenStreamComponents createComponents(String fieldName,
                                                  Reader reader)

Specified by:
  `createComponents` in class `Analyzer`